#include <SDL/SDL.h>
#include <GL/glut.h>
#include <GL/glext.h>
#include "trackball.hpp"
#include "mesh.hpp"
#include "cube.hpp";

void DrawGL();
void stop();



TrackBallCamera* camera;
Mesh* mesh;

int main(int argc, char *argv[]){
  atexit(stop); //stop() sera appelé quand on fera exit(0);
  SDL_Event event;
  SDL_Init(SDL_INIT_VIDEO);
  atexit(SDL_Quit);
  SDL_WM_SetCaption("Catmull Clark subdivision", NULL);
  SDL_SetVideoMode(1024, 768, 32, SDL_OPENGL);
  camera = new TrackBallCamera();
  mesh=make_cube();
  camera->setScrollSensivity(0.1);
  glClearColor(0.6, 0.6, 0.6, 1);
  
glEnable(GL_DEPTH_TEST);
  glMatrixMode( GL_PROJECTION );
  glLoadIdentity();
  gluPerspective(70,(double)640/480,1,1000);
  glMatrixMode( GL_MODELVIEW);
  while(true){
    while(SDL_PollEvent(&event)){
      switch(event.type){
      case SDL_QUIT:
	exit(0);
	break;
      case SDL_KEYDOWN:
	switch (event.key.keysym.sym){
	case SDLK_s:
	  mesh=mesh->next_catmull_clark_state();
	  break;
	case SDLK_ESCAPE:
	  exit(0);
	  break;
	default : //on a utilisé la touche P et la touche ECHAP, le reste est donné à la caméra
	  camera->OnKeyboard(event.key);
	}
	break;
      case SDL_MOUSEMOTION: //la souris est bougée, ça n'intéresse que la caméra
	camera->OnMouseMotion(event.motion);
	break;
      case SDL_MOUSEBUTTONUP:
      case SDL_MOUSEBUTTONDOWN:
	camera->OnMouseButton(event.button); //tous les événements boutons (up ou down) sont donnés à la caméra
	break;
      }
    }
    DrawGL();
  }
  return 0;
}


void DrawGL(){
  glClear( GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );
  glMatrixMode( GL_MODELVIEW );
  glLoadIdentity( );
  camera->look();
  mesh->draw();
  glFlush();
  SDL_GL_SwapBuffers();
}

void stop(){
  SDL_Quit();
}
