#include "mesh.hpp"
#include <iostream>
#include <math.h>
using namespace std;

Mesh::Mesh(usint nv,usint ne,usint nf){
  cout<<"la"<<endl;
  n_v=nv;
  n_e=ne;
  n_f=nf;
  vertices=new Vertice[nv];
  edges=new Edge[ne];
  faces=new Face[nf];
  normales=new Normale[nf];
  catmull_clark_state=0;
  face_points=NULL;
  edge_points=NULL;
  sub_mesh=NULL;
}

void Mesh::compute_normales(){
  for(usint i=0;i<n_f;i++){
    Vertice A=vertices[faces[i].v1];
    Vertice B=vertices[faces[i].v2];
    Vertice C=vertices[faces[i].v3];
    float u1,u2,u3,v1,v2,v3;
    u1=B.x-A.x;
    u2=B.y-A.y;
    u3=B.z-A.z;
    v1=C.x-B.x;
    v2=C.y-B.y;
    v3=C.z-B.z;
    normales[i].x=(u2*v3-u3*v2);
    normales[i].y=(u3*v1-u1*v3);
    normales[i].z=(u1*v2-u2*v1);
    float norme=sqrt(normales[i].x* normales[i].x+ normales[i].y* normales[i].y+ normales[i].z* normales[i].z);
    normales[i].x=normales[i].x/norme;
    normales[i].y=normales[i].y/norme;
    normales[i].z=normales[i].z/norme;
}
}

void Mesh::draw(){
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA, GL_ONE);
  glDisable(GL_DEPTH_TEST);
  glDisable(GL_LINE_SMOOTH);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_POLYGON_OFFSET_FILL);
  glPolygonOffset(1, 1);
  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
  float bleu[] = {0.2f, 0.5f, 0.9f, 0.9f};
  glMaterialfv(GL_FRONT, GL_DIFFUSE, bleu);
  
  glBegin(GL_QUADS);
  for(usint i=0;i<n_f;i++){
    glNormal3d(normales[i].x,normales[i].y,normales[i].z);
    glVertex3d(vertices[faces[i].v1].x,vertices[faces[i].v1].y,vertices[faces[i].v1].z);
    glVertex3d(vertices[faces[i].v2].x,vertices[faces[i].v2].y,vertices[faces[i].v2].z);
    glVertex3d(vertices[faces[i].v3].x,vertices[faces[i].v3].y,vertices[faces[i].v3].z);
    glVertex3d(vertices[faces[i].v4].x,vertices[faces[i].v4].y,vertices[faces[i].v4].z);
  }
  glEnd();
  glDisable(GL_POLYGON_OFFSET_FILL);
  glDisable(GL_LIGHT0);
  glDisable(GL_LIGHTING);
  glColor3f(0,0.8,0.8);
  glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
  glEnable(GL_LINE_SMOOTH);
  glEnable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  glHint(GL_LINE_SMOOTH_HINT,GL_NICEST);
  glLineWidth(1.7);
  glBegin(GL_LINES);
  for(usint i=0;i<n_e;i++){
    glVertex3d(vertices[edges[i].v1].x,vertices[edges[i].v1].y,vertices[edges[i].v1].z);
    glVertex3d(vertices[edges[i].v2].x,vertices[edges[i].v2].y,vertices[edges[i].v2].z);
  }
  glEnd();
  glPointSize(3);
  if(face_points!=NULL){
    glColor3f(1,0,0);
    glBegin(GL_POINTS);
    for(usint i=0;i<n_f;i++) glVertex3d(face_points[i].x,face_points[i].y,face_points[i].z);
    glEnd();
  }
  if(edge_points!=NULL){
    glColor3f(0,0,0);
    glBegin(GL_POINTS);
    for(usint i=0;i<n_e;i++) glVertex3d(edge_points[i].x,edge_points[i].y,edge_points[i].z);
    glEnd();
  }
  if(sub_mesh!=NULL){
    glBegin(GL_POINTS);
    for(usint i=0;i<sub_mesh->n_f;i++) glVertex3d(sub_mesh->vertices[i].x,sub_mesh->vertices[i].y,sub_mesh->vertices[i].z);
    glEnd();
  }
  if(catmull_clark_state==4){
    glBegin(GL_LINES);
    for(usint i=0;i<2*n_e;i++){
      glVertex3d(sub_mesh->vertices[sub_mesh->edges[i].v1].x,sub_mesh->vertices[sub_mesh->edges[i].v1].y,sub_mesh->vertices[sub_mesh->edges[i].v1].z);
      glVertex3d(sub_mesh->vertices[sub_mesh->edges[i].v2].x,sub_mesh->vertices[sub_mesh->edges[i].v2].y,sub_mesh->vertices[sub_mesh->edges[i].v2].z);
    }
    glEnd();
  }
 if(catmull_clark_state>=5){
    glBegin(GL_LINES);
    for(usint i=0;i<2*n_e+4*n_f;i++){
      glVertex3d(sub_mesh->vertices[sub_mesh->edges[i].v1].x,sub_mesh->vertices[sub_mesh->edges[i].v1].y,sub_mesh->vertices[sub_mesh->edges[i].v1].z);
      glVertex3d(sub_mesh->vertices[sub_mesh->edges[i].v2].x,sub_mesh->vertices[sub_mesh->edges[i].v2].y,sub_mesh->vertices[sub_mesh->edges[i].v2].z);
    }
    glEnd();
  }
 if(catmull_clark_state==6){
   // glEnable(GL_BLEND);
   //glBlendFunc(GL_SRC_ALPHA, GL_ONE);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_LINE_SMOOTH);
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glEnable(GL_POLYGON_OFFSET_FILL);
  glPolygonOffset(1, 1);
  glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
  float red[] = {0.5,0.5,0.5,1};
  glMaterialfv(GL_FRONT, GL_DIFFUSE,red);
   glBegin(GL_QUADS);
   for(usint i=0;i<sub_mesh->n_f;i++){
     glNormal3d(sub_mesh->normales[i].x,sub_mesh->normales[i].y,sub_mesh->normales[i].z);
     glVertex3d(sub_mesh->vertices[sub_mesh->faces[i].v1].x,sub_mesh->vertices[sub_mesh->faces[i].v1].y,sub_mesh->vertices[sub_mesh->faces[i].v1].z);
     glVertex3d(sub_mesh->vertices[sub_mesh->faces[i].v2].x,sub_mesh->vertices[sub_mesh->faces[i].v2].y,sub_mesh->vertices[sub_mesh->faces[i].v2].z);
     glVertex3d(sub_mesh->vertices[sub_mesh->faces[i].v3].x,sub_mesh->vertices[sub_mesh->faces[i].v3].y,sub_mesh->vertices[sub_mesh->faces[i].v3].z);
     glVertex3d(sub_mesh->vertices[sub_mesh->faces[i].v4].x,sub_mesh->vertices[sub_mesh->faces[i].v4].y,sub_mesh->vertices[sub_mesh->faces[i].v4].z);
   }
   glEnd();
 }
}

Mesh* Mesh::next_catmull_clark_state(){
  switch(catmull_clark_state){
  case 0:
    compute_face_points();
    break;
  case 1:
    compute_edge_points();
    break;
  case 2:
    create_sub_mesh();
    /*    delete[] face_points;
    delete[] edge_points;
    face_points=NULL;
    edge_points=NULL;*/
    break;
  case 3:
    compute_edges_of_submesh();
    break;
  case 5:
    compute_faces_of_submesh();
    break;
  case 6:
    return sub_mesh;
  default:
    break;
  }
  catmull_clark_state++;
  return this;
}

Vertice Mesh::barycentre(usint v1,usint v2,usint v3,usint v4){
  Vertice res;
  res.x=(vertices[v1].x+vertices[v2].x+vertices[v3].x+vertices[v4].x)/4;
  res.y=(vertices[v1].y+vertices[v2].y+vertices[v3].y+vertices[v4].y)/4;
  res.z=(vertices[v1].z+vertices[v2].z+vertices[v3].z+vertices[v4].z)/4;
  return res;
}

Vertice Mesh::barycentre(usint v1,usint v2,Vertice v3,Vertice v4){
  Vertice res;
  res.x=(vertices[v1].x+vertices[v2].x+v3.x+v4.x)/4;
  res.y=(vertices[v1].y+vertices[v2].y+v3.y+v4.y)/4;
  res.z=(vertices[v1].z+vertices[v2].z+v3.z+v4.z)/4;
  return res;
}

Vertice Mesh::barycentre(Vertice v1,Vertice v2,Vertice v3){
  Vertice res;
  res.x=(v1.x+v2.x+v3.x)/3;
  res.y=(v1.y+v2.y+v3.y)/3;
  res.z=(v1.z+v2.z+v3.z)/3;
  return res;
}

Vertice Mesh::barycentre(Vertice v1,Vertice v2,Vertice v3,Vertice v4){
  Vertice res;
  res.x=(v1.x+v2.x+v3.x+v4.x)/4;
  res.y=(v1.y+v2.y+v3.y+v4.y)/4;
  res.z=(v1.z+v2.z+v3.z+v4.z)/4;
  return res;
}
Vertice Mesh::face_point(usint f){
  Vertice a=vertices[faces[f].v1];
  Vertice b=vertices[faces[f].v2];
  Vertice c=vertices[faces[f].v3];
  Vertice d=vertices[faces[f].v4];
  return barycentre(a,b,c,d);
}

void Mesh::compute_face_points(){
  face_points=new Vertice[n_f];
  for(usint f=0;f<n_f;f++) face_points[f]=face_point(f);
}

bool Mesh::face_contains_vertice(usint f,usint v){
  return faces[f].v1==v or faces[f].v2==v or faces[f].v3==v or faces[f].v4==v;
}

bool Mesh::face_contains_edge(usint f,usint e){
  return face_contains_vertice(f,edges[e].v1) and face_contains_vertice(f,edges[e].v2);
}

Vertice Mesh::edge_point(usint e){
  Vertice a=vertices[edges[e].v1];
  Vertice b=vertices[edges[e].v2];
  usint f=0;
  for(;;f++){
    if(face_contains_edge(f,e)) break;
  }
  Vertice c=face_points[f];
  for(f++;;f++){
    if(face_contains_edge(f,e)) break;
  }
  Vertice d=face_points[f];
  return barycentre(a,b,c,d);
}

void Mesh::compute_edge_points(){
  edge_points=new Vertice[n_e];
  for(usint e=0;e<n_e;e++) edge_points[e]=edge_point(e);
}

bool Mesh::edge_contains_vertice(usint e,usint v){
  return edges[e].v1==v or edges[e].v2==v;
}

usint Mesh::edge_containing_vertices(usint v1,usint v2){
  for(usint i=0;i<n_e;i++){
    if(edge_contains_vertice(i,v1) and edge_contains_vertice(i,v2)) return i;
  }
  return 0;
}

NFaces Mesh::get_neighbouring_faces(usint e){
  NFaces res;
  usint i=0;
  usint k=0;
  while(i<n_f and k!=2){
    if(face_contains_edge(i,e)){
      if(k==0){
	res.f1=i;
      }
      else{
	res.f2=i;
      }
      k++;
    }
    i++;
  }
  return res;
}



TFaces Mesh::get_touching_faces(usint v){
  TFaces res;
  res.n=0;
  for(usint k=0;k<n_f;k++){
    if(face_contains_vertice(k,v)){
	res.f[res.n]=k;
	res.n++;
    }
  }

  if(res.n!=3 and res.n!=4) cout<<"Erreur"<<endl;
  return res;
}


TEdges Mesh::get_touching_edges(usint v){
  TEdges res;
  res.n=0;
  for(usint k=0;k<n_e;k++){
    if(edge_contains_vertice(k,v)){
      	res.e[res.n]=k;
	res.n++;
    }
  }
  if(res.n!=3 and res.n!=4) cout<<"Erreur"<<endl;
  return res;
}
Vertice Mesh::edge_mid_point(usint e){
  Vertice res;
  Vertice v1=vertices[edges[e].v1];
  Vertice v2=vertices[edges[e].v2];

  res.x=(v1.x+v2.x)/2;
  res.y=(v1.y+v2.y)/2;
  res.z=(v1.z+v2.z)/2;
  return res;
}

Vertice Mesh::get_transform_of_orginial_vertice(usint v){
  Vertice P=vertices[v];
  TFaces tf=get_touching_faces(v);
  Vertice F;
  int n=tf.n;
  if(n==3){
    F=barycentre(face_points[tf.f[0]],face_points[tf.f[1]],face_points[tf.f[2]]);
  }
  else{
    F=barycentre(face_points[tf.f[0]],face_points[tf.f[1]],face_points[tf.f[2]],face_points[tf.f[3]]);
  }
  TEdges te=get_touching_edges(v);
  Vertice R;
  if(n==3){
    R=barycentre(edge_mid_point(te.e[0]),edge_mid_point(te.e[1]),edge_mid_point(te.e[2]));
  }
  else{
    R=barycentre(edge_mid_point(te.e[0]),edge_mid_point(te.e[1]),edge_mid_point(te.e[2]),edge_mid_point(te.e[3]));
  }
  Vertice res;
  res.x=(F.x+2*R.x+(n-3)*P.x)/(n);
  res.y=(F.y+2*R.y+(n-3)*P.y)/(n);
  res.z=(F.z+2*R.z+(n-3)*P.z)/(n);
  return res;
}

void Mesh::create_sub_mesh(){
  sub_mesh=new Mesh(n_v+n_f+n_e,2*n_e+4*n_f,4*n_f);//2*n_e+4*n_f,4*n_f);
  usint i=0;
  for(usint k=0;k<n_v;k++) sub_mesh->vertices[i++]=get_transform_of_orginial_vertice(k);
  for(usint k=0;k<n_f;k++) sub_mesh->vertices[i++]=face_points[k];
  for(usint k=0;k<n_e;k++) sub_mesh->vertices[i++]=edge_points[k];
}

void Mesh::compute_edges_of_submesh(){
  cout<<"Creating edges of submesh"<<endl;
  //Edges of Original vertice to edge points
  usint i=0;
  for(usint k=0;k<n_e;k++){
    sub_mesh->edges[i].v1=n_v+n_f+k;
    sub_mesh->edges[i].v2=edges[k].v1;
     i++;
    sub_mesh->edges[i].v1=n_v+n_f+k;
    sub_mesh->edges[i].v2=edges[k].v2;
     i++;
  }
  for(usint k=0;k<n_f;k++){
    for(usint j=0;j<n_e;j++){
      if(face_contains_edge(k,j)){
	sub_mesh->edges[i].v1=n_v+k;
	sub_mesh->edges[i].v2=n_v+n_f+j;
	i++;
      }
    }
  }
}

void Mesh::compute_faces_of_submesh(){
  cout<<"Creating faces of submesh"<<endl;
  usint i=0;
  for(usint k=0;k<n_f;k++){
    sub_mesh->faces[i].v1=faces[k].v1;
    sub_mesh->faces[i].v2=n_v+n_f+edge_containing_vertices(faces[k].v1,faces[k].v2);
    sub_mesh->faces[i].v3=n_v+k;
    sub_mesh->faces[i].v4=n_v+n_f+edge_containing_vertices(faces[k].v4,faces[k].v1);
    i++;

    sub_mesh->faces[i].v1=faces[k].v2;
    sub_mesh->faces[i].v2=n_v+n_f+edge_containing_vertices(faces[k].v2,faces[k].v3);
    sub_mesh->faces[i].v3=n_v+k;
    sub_mesh->faces[i].v4=n_v+n_f+edge_containing_vertices(faces[k].v1,faces[k].v2);
    i++;

    sub_mesh->faces[i].v1=faces[k].v3;
    sub_mesh->faces[i].v2=n_v+n_f+edge_containing_vertices(faces[k].v3,faces[k].v4);
    sub_mesh->faces[i].v3=n_v+k;
    sub_mesh->faces[i].v4=n_v+n_f+edge_containing_vertices(faces[k].v2,faces[k].v3);
    i++;

    sub_mesh->faces[i].v1=faces[k].v4;
    sub_mesh->faces[i].v2=n_v+n_f+edge_containing_vertices(faces[k].v4,faces[k].v1);
    sub_mesh->faces[i].v3=n_v+k;
    sub_mesh->faces[i].v4=n_v+n_f+edge_containing_vertices(faces[k].v3,faces[k].v4);
    i++;
  }
  sub_mesh->compute_normales();
}
